/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is LightSMS.
 *
 * The Initial Developer of the Original Code is
 * Byungwook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var main={
  onLoad:function(){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    this.branch = prefService.getBranch("lightsms.");
    this.branch.QueryInterface(Components.interfaces.nsIPrefBranch2);

    try {
      main.nsILightSMS = Components.classes["@mozilla.org/LightSMS;1"]
                                                  .getService(Components.interfaces.nsILightSMS);
      main.nsILightSMS.addListener(main);
    } catch (e){}
    window.removeEventListener("load", main.onLoad, false);


    document.getElementById("sizer2").value="\uac00\ub098\ub2e4\ub77c\ub9c8\ubc14\uc0ac\uc544";
    var width=Math.max(document.getElementById("sizer1").boxObject.width,document.getElementById("sizer2").boxObject.width);
    document.getElementById("sizer").collapsed=true;

    var obj=document.getElementById("msg").inputField;
    obj.spellcheck=false;
    obj.style.overflowX="hidden";
    obj.style.overflowY="scroll";
    var d=document.getElementById("msg").boxObject.width-obj.scrollWidth;
//Components.utils.reportError(d+" + "+width+" "+document.getElementById("msg").inputField.scrollWidth);
//Components.utils.reportError(document.getElementById("msg").inputField.scrollWidth);
    document.getElementById("msg").width=d+width+4;
//Components.utils.reportError(document.getElementById("msg").inputField.scrollWidth);
    document.getElementById("msg").focus();
  },
  onHistSel: function(){
    var t=document.getElementById("history").value;
    t=t.split("\t");
    txtinput(document.getElementById("msg"),t[0].replace(/\\n/g,"\n"));
    document.getElementById("receiver").value=t[1];
    document.getElementById("sender").value=t[2];
    this.setStatus(t[3]);
  },
  onReset: function(){
    document.getElementById("history").value="";
    txtinput(document.getElementById("msg"),"");
    document.getElementById("receiver").value="";
    this.setStatus("");
  },
  checkValue : function(name,desc){
    var val=document.getElementById(name).value
    if(!val){
      alert(desc);
      return null;
    }else return val;
  },
  onSend :function(){
    this.setStatus("");
    ////////////////////////////////////////////////
    var sender=document.getElementById("sender").value;
    if(sender)sender=sender.replace(/\D/g,"")
    if(!sender){
      alert(this.getString("NoSenderNumber"));
      return;
    }
    this.branch.setCharPref("sender",sender);
    document.getElementById("sender").value=sender;
    ////////////////////////////////////////////////
    var receiver=document.getElementById("receiver").value;
    var receiverStr=receiver;
    if(receiver)receiver=receiver.match(/\d{3,}/);
    if(!receiver){
      alert(this.getString("NoReceiverNumber"));
      return;
    }
    var save=document.getElementById("saveaddr").checked
    this.branch.setBoolPref("saveaddr",save);
    if(save){
      var db = Components.classes["@mozilla.org/autocomplete/search;1?name=text-file"]
                    .getService (Components.interfaces.nsITextFile);
      db.addEntry("smsaddr.txt", receiverStr,true);
    }
    ////////////////////////////////////////////////
    var txt=getText();
    if(!txt){
      alert(this.getString("NoMessage"));
      return;}
    main.nsILightSMS.sendSMS(receiverStr,txt);
  },
  setStatus:function (str){
    document.getElementById("status").value=str;
  }
}

function txtinput(textbox,str){
  if(str==null)str=textbox.value;
  var cols=textbox.getAttribute("cols");
  var maxlength=textbox.getAttribute("maxlength");
  var count=0;
  var str2="";
  var pos=0;
  var newlines=0;
  var start=textbox.selectionStart;
  for(var i=0;i<str.length;i++){
    var c=str.charAt(i);
    var code=str.charCodeAt(i);
    if(c=='\n'){
      if(pos<cols){
        if(count>=maxlength)break;
        if(pos!=cols-1||i>=str.length-1||str.charCodeAt(i+1)<255){
          count++;
        }
      }
      pos=0;
    }else{
      if(str.charCodeAt(i)<255){
        if(count>=maxlength)break;
        count++;
        pos++;
        if(pos>cols){
          pos=0;
          str2+='\n';
          if(i<start)newlines++;
        }
      }else{
        if(count>=maxlength-1)break;
        count+=2;
        pos+=2;
        if(pos>cols){
          pos=2;
          str2+='\n';
          if(i<start)newlines++;
        }
      }
    }
    str2+=c;
  }
  document.getElementById("count").value=count+"/80";
  var end=textbox.selectionEnd;
  textbox.value=str2;
  textbox.selectionStart=start+newlines;
  textbox.selectionEnd=end+newlines;
}
function getText(){
  var str=document.getElementById("msg").value;
  var cols=document.getElementById("msg").getAttribute("cols");
  var str2="";
  var pos=0;
  for(var i=0;i<str.length;i++){
    var c=str.charAt(i);
    var code=str.charCodeAt(i);
    if(c=='\n'){
      if(pos<cols){
        if(pos!=cols-1||i>=str.length-1||str.charCodeAt(i+1)<255){
          str2+=c;
        }
      }
      pos=0;
    }else{
      if(str.charCodeAt(i)<255){
        pos++;
        if(pos>cols){
          pos=0;
        }
      }else{
        pos+=2;
        if(pos>cols)pos=2;
      }
      str2+=c;
    }
  }
  return str2;
}

main.getString = function(aName) {
  var strbundle = document.getElementById("stringbundle");
  return strbundle.getString(aName);
}

main.onStateChange = function(aID,aData){
//Components.utils.reportError(aID+" "+aData);
  switch(aID){
  case Components.interfaces.nsILightSMS.ST_LOGIN:
    switch(aData){
    case Components.interfaces.nsILightSMS.RS_FAIL:
      this.setStatus(this.getString("LoginFail"));
      break;
    case Components.interfaces.nsILightSMS.RS_SUCC:
      this.setStatus(this.getString("LoginSucc"));
      break;
    case Components.interfaces.nsILightSMS.RS_TRY:
      this.setStatus(this.getString("LoginTry"));
      break;
    case Components.interfaces.nsILightSMS.RS_RETRY:
      this.setStatus(this.getString("LoginRetry"));
      break;
    }
    break;
  case Components.interfaces.nsILightSMS.ST_FREECOUNT:
    document.getElementById("freecount").value=aData;
    break;
  case Components.interfaces.nsILightSMS.ST_SEND:
    switch(aData){
    case Components.interfaces.nsILightSMS.RS_FAIL:
      this.setStatus(this.getString("Failed"));
      break;
    case Components.interfaces.nsILightSMS.RS_SUCC:
      this.setStatus(this.getString("Sent"));
      if(document.getElementById("freecount").value>0){
        document.getElementById("freecount").value--;
      }
      txtinput(document.getElementById("msg"),"");
      break;
    case Components.interfaces.nsILightSMS.RS_TRY:
      this.setStatus(this.getString("Sending"));
      break;
    }
    break;
  }
}

main.onUnload = function() {
  // remove the listener
  if (main.nsILightSMS)main.nsILightSMS.removeListener(main);
  main = null;
}


window.addEventListener("load", main.onLoad, false);
window.addEventListener("unload", main.onUnload, false);
